from itertools import zip_longest
 
class Lunar(object):
 
    def __init__(self, n):
        self.n = n
        assert isinstance(n, int)
 
    def __add__(self, other):
        n = self.n
        res = []
        for ni, mi in zip_longest(reversed(str(n)), reversed(str(other)), fillvalue="0"):
            res.append(max(ni, mi))
        return Lunar(int("".join(reversed(res))))
 
    def __mul__(self, other):
        n = self.n
        res = Lunar(0)
        for shift, mi in enumerate(reversed(str(other))):
            L = ["0"] * shift + [min(mi, ni) for ni in reversed(str(n))]
            res = res + Lunar(int("".join(reversed(L))))
        return res
 
    def __pow__(self, p):
        if p == 0:
            return Lunar(1)
        if p == 1:
            return Lunar(self.n)
        if p == 2:
            return self * self
        if p % 2 == 0:
            return self.__pow__(p // 2) ** 2
        else:
            return self.__pow__(p // 2) ** 2 * self
 
    def __str__(self):
        return str(self.n)

a = Lunar(int(input()))
b = Lunar(int(input()))

print(a + b, a * b)