from collections import defaultdict
import functools

class Graph:
    def __init__(self):
        self.graph = defaultdict(list)

    def addEdge(self, u, v):
        self.graph[u].append(v)

    @functools.lru_cache(maxsize = 1000)
    def BFS(self, s, maxlength):
        guarding = []

        visited = [False] * (max(self.graph) + 1)
        queue = []
        queue.append([s, 0])
        visited[s] = True

        while queue:
            s, length = queue.pop(0)
            guarding.append(s)
            for i in self.graph[s]:
                if (not visited[i]) and (length < maxlength):
                    queue.append([i, length + 1])
                    visited[i] = True
        return guarding

n, m, k = map(int, input().split())

roads = Graph()
for i in range(m):
    a, b = map(int, input().split())
    roads.addEdge(a, b)
    roads.addEdge(b, a)

if (m != 0 and k != 0):
    guarding = []
    for i in range(k):
        local_guard = []
        p, h = map(int, input().split())
        guarding += roads.BFS(p, h)
    guarding = sorted(set(guarding))
    length = len(guarding)
    if (length == 0):
        print('')
    else:
        print(length)
        print(str(guarding).replace('[', '').replace(']', '').replace(", ", ' '))
if (k == 0):
    print('')
elif (m == 0):
    guarding = []
    for i in range(k):
        local_guard = []
        p, h = map(int, input().split())
        guarding.append(p)

    guarding = sorted(set(guarding))
    print(len(guarding))
    print(str(guarding).replace('[', '').replace(']', '').replace(", ", ' '))